// FOXWizardaw.cpp : implementation file
//

#include "stdafx.h"
#include "FOXWizard.h"
#include "FOXWizardaw.h"
#include "chooser.h"

#import "C:\\Program Files\\Microsoft Visual Studio\\Common\\MsDev98\\Bin\\IDE\\DevBld.Pkg"

#ifdef _PSEUDO_DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// This is called immediately after the custom AppWizard is loaded.  Initialize
//  the state of the custom AppWizard here.
void CFOXWizardAppWiz::InitCustomAppWiz()
{
	// Create a new dialog chooser; CDialogChooser's constructor initializes
	//  its internal array with pointers to the steps.
	m_pChooser = new CDialogChooser;

	// Set the maximum number of steps.
	SetNumberOfSteps(LAST_DLG);

	// TODO: Add any other custom AppWizard-wide initialization here.
}

// This is called just before the custom AppWizard is unloaded.
void CFOXWizardAppWiz::ExitCustomAppWiz()
{
	// Deallocate memory used for the dialog chooser
	ASSERT(m_pChooser != NULL);
	delete m_pChooser;
	m_pChooser = NULL;

	// TODO: Add code here to deallocate resources used by the custom AppWizard
}

// This is called when the user clicks "Create..." on the New Project dialog
//  or "Next" on one of the custom AppWizard's steps.
CAppWizStepDlg* CFOXWizardAppWiz::Next(CAppWizStepDlg* pDlg)
{
	// Delegate to the dialog chooser
	return m_pChooser->Next(pDlg);
}

// This is called when the user clicks "Back" on one of the custom
//  AppWizard's steps.
CAppWizStepDlg* CFOXWizardAppWiz::Back(CAppWizStepDlg* pDlg)
{
	// Delegate to the dialog chooser
	return m_pChooser->Back(pDlg);
}

void CFOXWizardAppWiz::CustomizeProject(IBuildProject* pProject)
{
	// TODO: Add code here to customize the project.  If you don't wish
	//  to customize project, you may remove this virtual override.
	
	// This is called immediately after the default Debug and Release
	//  configurations have been created for each platform.  You may customize
	//  existing configurations on this project by using the methods
	//  of IBuildProject and IConfiguration such as AddToolSettings,
	//  RemoveToolSettings, and AddCustomBuildStep. These are documented in
	//  the Developer Studio object model documentation.

	// WARNING!!  IBuildProject and all interfaces you can get from it are OLE
	//  COM interfaces.  You must be careful to release all new interfaces
	//  you acquire.  In accordance with the standard rules of COM, you must
	//  NOT release pProject, unless you explicitly AddRef it, since pProject
	//  is passed as an "in" parameter to this function.  See the documentation
	//  on CCustomAppWiz::CustomizeProject for more information.

	using namespace DSProjectSystem;
	long lNumConfigs;
	IConfigurationsPtr pConfigs;
	IBuildProjectPtr pProj;

	// Needed to convert IBuildProject to the DSProjectSystem namespace
	pProj.Attach((DSProjectSystem::IBuildProject*)pProject, true);
	pProj->get_Configurations(&pConfigs);
	pConfigs->get_Count(&lNumConfigs);

	//Get each individual configuration
	for (long j = 1 ; j < lNumConfigs+1 ; j++)
	{
		_bstr_t varTool;
		_bstr_t varSwitch;
		IConfigurationPtr pConfig;
		_variant_t varj = j;
		pConfig = pConfigs->Item(varj);

		// Remove MFC stuff
		varTool   = "cl.exe";
		varSwitch = "/D \"_AFXDLL\"";
		pConfig->RemoveToolSettings(varTool, varSwitch, varj);

		varTool   = "rc.exe";
		varSwitch = "/d \"_AFXDLL\"";
		pConfig->RemoveToolSettings(varTool, varSwitch, varj);

		// Add preprocessor directives
		varTool   = "cl.exe";
		varSwitch = "/I\"\\fox\\include\"";
		pConfig->AddToolSettings(varTool, varSwitch, varj);

		varSwitch = "/D \"FX_NATIVE_WIN32\"";
		pConfig->AddToolSettings(varTool, varSwitch, varj);

		varSwitch = "/D \"FOXDLL\"";
		pConfig->AddToolSettings(varTool, varSwitch, varj);

		// Change from a windows to a console application

		varTool   = "cl.exe";

		varSwitch = "/D \"_WINDOWS\"";
		pConfig->RemoveToolSettings(varTool, varSwitch, varj);

		varSwitch = "/D \"_CONSOLE\"";
		pConfig->AddToolSettings(varTool, varSwitch, varj);

		varTool = "link.exe";

		varSwitch = "/entry:\"mainCRTStartup\"";
		pConfig->AddToolSettings(varTool, varSwitch, varj);

		if ( pConfig->Name == (pProj->Name + _bstr_t(" - Win32 Release")) )
		{
			varSwitch = "\\fox\\lib\\foxdll.lib "
						"kernel32.lib user32.lib gdi32.lib winspool.lib "
						"comdlg32.lib advapi32.lib shell32.lib ole32.lib "
						"oleaut32.lib uuid.lib odbc32.lib odbccp32.lib";
		}
		else
		{
			varSwitch = "\\fox\\lib\\foxdlld.lib "
						"kernel32.lib user32.lib gdi32.lib winspool.lib "
						"comdlg32.lib advapi32.lib shell32.lib ole32.lib "
						"oleaut32.lib uuid.lib odbc32.lib odbccp32.lib";
		}
		pConfig->AddToolSettings(varTool, varSwitch, varj);

		// Add all the required files
/*
		varTool   = "link.exe";

		_bstr_t varFile;

		varFile = "\\work\\nw\\CDBDatabase.cpp";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CDBDatabase.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWBaseDate.cpp";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWBaseDate.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWRegistry.cpp";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWRegistry.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWService.cpp";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWService.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWThread.cpp";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\CNWThread.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\nw\\NWHelper.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\mssdk\\include\\sqldb.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\mssdk\\include\\sqlfront.h";
		pProject->AddFile(varFile, vtMissing);

		varFile = "\\work\\mssdk\\lib\\ntwdblib.lib";
		pProject->AddFile(varFile, vtMissing);

		// Add the dblib library

		varTool = "link.exe";
		
		varSwitch = "\\work\\mssdk\\lib\\ntwdblib.lib "
					"kernel32.lib user32.lib gdi32.lib winspool.lib "
				    "comdlg32.lib advapi32.lib shell32.lib ole32.lib "
				    "oleaut32.lib uuid.lib odbc32.lib odbccp32.lib";
		pConfig->AddToolSettings(varTool, varSwitch, varj);
*/
	}
}


// Here we define one instance of the CFOXWizardAppWiz class.  You can access
//  m_Dictionary and any other public members of this class through the
//  global FOXWizardaw.
CFOXWizardAppWiz FOXWizardaw;

